#
#
# connectivity.py
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
import dbus
import blueman.blueman as blueman
import gobject

_ = Globals._

class connectivity():
	def __init__(self):
		
		self.bus = dbus.SystemBus();
		
		self.bus.add_signal_receiver(self.device_connected_signal, 'RemoteDeviceConnected', 'org.bluez.Adapter', 'org.bluez', None)
		self.bus.add_signal_receiver(self.device_disconnected_signal, 'RemoteDeviceDisconnected', 'org.bluez.Adapter', 'org.bluez', None)	
		
		self.connections = []

		
	
	def Deinit(self):
		self.bus.remove_signal_receiver(self.device_connected_signal, 'RemoteDeviceConnected', 'org.bluez.Adapter', 'org.bluez', None)
		self.bus.remove_signal_receiver(self.device_disconnected_signal, 'RemoteDeviceDisconnected', 'org.bluez.Adapter', 'org.bluez', None)
	

	
	def device_connected_signal(self, addr):
		if not addr in self.connections:
			self.connections.append(addr)
			self.connection((True, addr))
		
	
	def device_disconnected_signal(self, addr):
		if addr in self.connections:
			self.connections.remove(addr)
		self.connection((False, addr))
		
	
	
	def connection(self,result):
		
		addr = result[1]
		#print addr + " connected"
		if result[0]:
			if Globals.Settings.connection_notifications:
				name = Globals.adapter.GetRemoteName(addr)
				Globals.Notification.show(_("Device Connected"), _("Device %(addr)s (%(name)s) Has Connected") % {"addr": addr,"name": name}, im="con_1.png")
		else:
			if Globals.Settings.connection_notifications:
				name = Globals.adapter.GetRemoteName(addr)
				Globals.Notification.show(_("Device Disconnected"), _("Device %(addr)s (%(name)s) Has Disconnected") % {"addr": addr,"name": name}, im="con_2.png")
		
		
		for i in range(Globals.main_list.row_count):
			rdata = Globals.main_list.get_row(i)
			
			bonded = rdata[3]
			connected =rdata[2]
			bdaddr = rdata[0]
			iter = rdata[4]
		
			
			if bdaddr == addr and not connected and result[0]:
				try:
					if addr == Globals.main_list.get_selected_row()[0]:
						Globals.window.mi_disconnect.set_sensitive(True)
				except:
					pass
				
				Globals.main_list.set_data(iter, 7, True)
				cinfo = blueman.conn_info(addr, Globals.Settings.adapter)
				Globals.main_list.update_signal(cinfo, addr, iter, True)
				gobject.timeout_add(1000, Globals.main_list.update_signal, cinfo, addr, iter)
	
			

				break
			
			elif bdaddr == addr and connected and not result[0]:
				try:
					if addr == Globals.main_list.get_selected_row()[0]:
						Globals.window.mi_disconnect.set_sensitive(False)
				except:
					pass
					
				Globals.main_list.set_data(iter, 7, False)
				Globals.main_list.set_data(iter, 5, None)
				Globals.main_list.set_data(iter, 9, None)
				Globals.main_list.set_data(iter, 10, None)
				Globals.window.mi_disconnect.set_sensitive(False)


				break

