#
#
# services.py - services module
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
import dbus

from blueman.Services.bluetooth.audio import audio
from blueman.Services.bluetooth.network import network
from blueman.Services.bluetooth.input import input
from blueman.Services.bluetooth.serial import serial

class services:
    
    	def __init__(self):
        	self.bus = dbus.SystemBus()
        	self.services = {}
        
        	Globals.dbg.info("Initializing 'Bluetooth.services' Class", 6)
        
        	services = Globals.Manager.ListServices()
        	for i in range(len(services)):
            
            		obj = self.bus.get_object('org.bluez', services[i])
            		service = dbus.Interface(obj, 'org.bluez.Service')
            		id = service.GetIdentifier()
            		if id == "network":
                		self.services["network"] = network()
                
            		if id == "audio":
            			self.services["audio"] = audio()
            			
            		if id == "input":
            			self.services["input"] = input()
            			
            		if id == "serial":
            			self.services["serial"] = serial()

            
	def get(self, id):
		try:
			return self.services[id]
        	except:
           		return None
           		
        def list(self):
        	return self.services
           		
	
	def get_service_status(self, identifier):
		service = self.get(identifier)
		if service != None:
			if service.service.IsRunning():
				return 1
			else:
				return 0
		else:
			return -1   

