#
#
# animation.py
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
import gobject
import gtk

class animation:
	

	def __init__(self, image, images, rate=1, rev=False):
		self.pixbuffs = []
		self.timer = None
		self.current = 0
		self.image = None
		
		self.image  = image
		self.rate = 1000/rate
			
		for i in range(len(images)):
			self.pixbuffs.append(gtk.gdk.pixbuf_new_from_file(Globals.IMAGE_DIR + images[i]))
			

		if len(self.pixbuffs) > 2 and rev:
			ln = len(self.pixbuffs)
			for i in range(len(self.pixbuffs)):
				if i != 0 and i != ln-1:
					self.pixbuffs.append(self.pixbuffs[ln -1 - i])
				
			print self.pixbuffs
			
	def status(self):
		if self.timer:
			return True
		else:
			return False
	
	def get_rate(self):
		return self.rate*1000
	
	def set_rate(self, rate):
		if not self.rate == (1000/rate):
			self.rate = 1000/rate	
			self.stop()
			self.start()
	
	def start(self):
		self.timer = gobject.timeout_add (self.rate, self._animation)
		
	def stop(self):
		if self.timer:
			gobject.source_remove(self.timer)
			self.image.set_from_pixbuf(self.pixbuffs[0])
			self.timer = None
		
	def _animation(self):
		self.current+=1
		if self.current > (len(self.pixbuffs)-1):
			self.current = 0
		self.image.set_from_pixbuf(self.pixbuffs[self.current])
		#print "setting " + str(self.current)
		
		return 1

