#
#
# auth_dialog.py
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
import gtk

from blueman.Gui.generic_dialog import generic_dialog

_ = Globals._

class auth_dialog(generic_dialog):
	def __init__(self, event, address, desc):
		generic_dialog.__init__(self, "auth.glade", "auth")
		
		self.event = event
        

        	self.xml.signal_autoconnect(self)
        	self.result = None
        	
		self.l_service = self.xml.get_widget("l_service")
		self.l_device = self.xml.get_widget("l_device")
		
		self.l_service.set_markup("<i>" + desc + "</i>")
		
		name = Globals.adapter.GetRemoteName(address)
		
		self.l_device.set_markup("%s <b>(%s)</b>" % (address, name))  
		
		self.dialog.show()      	
        	
   	def __dialog_response__(self, dialog, response):
   		self.result = response
   		self.event.set()

   			
   	def close(self):
   		self.__destroy__()
   		
   	def get_result(self):
   		return self.result
