#
#
# 
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
import gtk
import pango

class device_selector_combobox:
	def __init__(self, combobox, callback):
		self.callback = callback
		self.cb = combobox
		self.cb.connect("changed", self.on_changed)
		self.liststore = gtk.ListStore(str, str)

		self.cb.set_model(self.liststore)
		
		cell = gtk.CellRendererText()
		cell.set_property("xalign",1)
		cell.set_property("alignment",pango.ALIGN_RIGHT)
		
		self.cb.pack_start(cell, True)
		self.cb.add_attribute(cell, 'markup', 1) 

		self.cb.set_text_column(0)
		
		self.populate()
		
	def populate(self):
		list = Globals.adapter.ListRemoteDevices()
		for i in range(len(list)):
			self.liststore.append([list[i], "<b>"+Globals.adapter.GetRemoteName(list[i])+"</b>"])
			
	def on_changed(self, widget):
	        if Globals.adapter.is_valid_address(self.get_text()):
			self.callback(True)
		else:
			self.callback(False)
			
	def get_text(self):
		return self.cb.get_active_text()
		

