#
#
# generic_dialog.py - generic dialog module
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
import gtk

class generic_dialog:

	def __init__(self, glade, widget_id):
		self.xml = gtk.glade.XML(Globals.GLADE_DIR + "/" + glade)

		Globals.dbg.info("Initializing Dialog %s from %s" % (widget_id, glade), 6)
		
		self.dialog = self.xml.get_widget(widget_id)
		self.dialog.connect("response", self.__dialog_response__)
		
		self.glade = glade
		self.widget_id = widget_id
		
		

	def __dialog_response__(self, dialog, response):
		Globals.dbg.info("Dialog %s response code: %s" % (dialog, response), 7)
		if not self.dialog_response(dialog, response):
			self.__destroy__()

	def __destroy__(self):
		self.dialog.destroy()
		Globals.dbg.info("Destroying dialog %s from %s" % (self.widget_id, self.glade), 6)
		
	#virtual
	def dialog_response(self, dialog, response):
		pass
		
	def dialog_destroy( self ):
		pass
