#
#
# blueman - main_list library
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
import gtk
import os
import threading
import blueman.blueman as blueman
import gobject

_ = Globals._
ngettext = Globals.ngettext
class main_list():
	
	def __init__(self, xml):
		self.tooltip_row = -1
		self.tooltip_col = None
		self.xml = xml

		#main text, last seen text, address, name, device logo, rssi pb, bondedpb, connected, bonded, lq pb, tpl pb, rssi, lq, tpl, trust pb, trusted
		self.liststore = gtk.ListStore(str,str,str,str,'GdkPixbuf', 'GdkPixbuf', 'GdkPixbuf',bool,bool, 'GdkPixbuf', 'GdkPixbuf', float, float, float, 'GdkPixbuf', bool)
		self.treeview = self.xml.get_widget("list");
		self.treeview.set_property("has-tooltip", True)
		self.treeview.connect("query-tooltip", self.tooltip_query)

		self.xml.signal_connect("on_list_cursor_changed", self.on_list_cursor_changed)

		self.treeview.set_model(self.liststore);


		self.tvcolumn = gtk.TreeViewColumn()
		self.tvcolumn2 = gtk.TreeViewColumn()
		self.tvcolumn3 = gtk.TreeViewColumn()
		self.tvcolumn4 = gtk.TreeViewColumn()
		self.tvcolumn5 = gtk.TreeViewColumn()
		self.tvcolumn6 = gtk.TreeViewColumn()
		self.tvcolumn3.set_expand(True)
		self.tvcolumn3.set_alignment(0.5)

		self.treeview.append_column(self.tvcolumn)
		self.treeview.append_column(self.tvcolumn2)
		self.treeview.append_column(self.tvcolumn3)
		self.treeview.append_column(self.tvcolumn4)
		self.treeview.append_column(self.tvcolumn5)
		self.treeview.append_column(self.tvcolumn6)


		self.cellpb1 = gtk.CellRendererPixbuf()
		self.cellpb2 = gtk.CellRendererPixbuf()
		self.cellpb3 = gtk.CellRendererPixbuf()
		self.cellpb4 = gtk.CellRendererPixbuf()
		self.cellpb5 = gtk.CellRendererPixbuf()
		self.cellpb6 = gtk.CellRendererPixbuf()

		self.cell = gtk.CellRendererText()
		self.cell2 = gtk.CellRendererText()
		self.cell2.set_property("xalign", 0.5)

		self.tvcolumn.pack_start(self.cellpb1, False)
		self.tvcolumn2.pack_start(self.cell, False)
		self.tvcolumn3.pack_start(self.cell2, True)
		#self.tvcolumn.pack_start(self.cell2, True)


		#self.tvcolumn.pack_start(self.cell3, False)




		self.tvcolumn4.pack_start(self.cellpb2, False)
		self.tvcolumn4.pack_start(self.cellpb3, False)
		self.tvcolumn4.pack_start(self.cellpb4, False)
		self.tvcolumn5.pack_start(self.cellpb5, False)
		self.tvcolumn6.pack_start(self.cellpb6, False)


		self.tvcolumn.set_attributes(self.cellpb1, pixbuf=4) #dev logo
		self.tvcolumn2.set_attributes(self.cell, markup=0)
		self.tvcolumn3.set_attributes(self.cell2, markup=1)

		
		self.tvcolumn4.set_attributes(self.cellpb2, pixbuf=5) #lq pb
		self.tvcolumn4.set_attributes(self.cellpb3, pixbuf=9) #rssi pb
		self.tvcolumn4.set_attributes(self.cellpb4, pixbuf=10) #tpl pb
		self.tvcolumn5.set_attributes(self.cellpb5, pixbuf=6) #bonded pb
		self.tvcolumn6.set_attributes(self.cellpb6, pixbuf=14) #trust pb


		self.row_count = 0
		
	def tooltip_query(self, tw, x, y, kb, tooltip):

		#print args
		#args[4].set_text("test"+str(args[1]))
		
		path = self.treeview.get_path_at_pos(x, y)


		if path:
			if path[0][0] != self.tooltip_row or path[1] != self.tooltip_col:
				self.tooltip_row = path[0][0]
				self.tooltip_col = path[1]
				return False
			if path[1] == self.tvcolumn5:
				iter = self.get_iter_by_row(path[0][0])
				#print iter
				if self.liststore.get(iter, 8)[0]:
					tooltip.set_markup(_("<b>Bonded</b>"))
					self.tooltip_row = path[0][0]
					self.tooltip_col = path[1]
					return True
			
			if path[1] == self.tvcolumn6:
				iter = self.get_iter_by_row(path[0][0])
				#print iter
				if self.liststore.get(iter, 15)[0]:
					tooltip.set_markup(_("<b>Trusted</b>"))
					self.tooltip_row = path[0][0]
					self.tooltip_col = path[1]
					return True
			
			if path[1] == self.tvcolumn4:
				iter = self.get_iter_by_row(path[0][0])
				#print iter
				dt = self.liststore.get(iter, 7)
				#print dt
				if dt[0]:
					rssi = self.liststore.get(iter, 11)[0]
					lq = self.liststore.get(iter, 12)[0]
					tpl = self.liststore.get(iter, 13)[0]
					
					if rssi < 30:
						rssi_state = _("Poor")
					
					if rssi < 40 and rssi > 30:
						rssi_state = _("Sub-optimal")

					elif rssi > 40 and rssi < 60:
						rssi_state = _("Optimal")
					
					elif rssi > 60:
						rssi_state = _("Much")
					
					elif rssi > 70:
						rssi_state = _("Too much")
						
					
					if tpl < 30:
						tpl_state = _("Low")
					
					if tpl < 40 and tpl > 30:
						tpl_state = _("Sub-optimal")

					elif tpl > 40 and rssi < 60:
						tpl_state = _("Optimal")
					
					elif tpl > 60:
						tpl_state = _("High")
					
					elif tpl > 70:
						tpl_state = _("Very High")
						
											
					tooltip.set_markup(_("<b>Connected</b>\nReceived Signal Strength: %(rssi)u%% <i>(%(rssi_state)s)</i>\nLink Quality: %(lq)u%%\nTransmit Power Level: %(tpl)u%% <i>(%(tpl_state)s)</i>") % {"rssi_state": rssi_state, "rssi":rssi, "lq":lq, "tpl":tpl, "tpl_state": tpl_state})
					self.tooltip_row = path[0][0]
					self.tooltip_col = path[1]
					return True	
		return False
	
	def gen_img_path(self, value, prefix, suffix):
		im = int(round(value,-1))
		return prefix + str(im) + suffix

	
	def set_signal(self, addr, value, pb_col, data_col, im_prefix, im_suffix):
		for i in range(len(self.liststore)):	
			iter = self.liststore[i].iter
			data = self.liststore.get(iter, 2, data_col)

			if data[0] == addr and round(data[1],-1) != round(value, -1):
				img = self.gen_img_path(value, Globals.IMAGE_DIR + im_prefix, im_suffix)
				pb = gtk.gdk.pixbuf_new_from_file(img)

				self.set_data(iter, pb_col, pb)
				self.set_data(iter, data_col, value)
	
	def set_signal_for_iter(self, iter, value, pb_col, data_col, im_prefix, im_suffix):

		data = self.liststore.get(iter, 2, data_col)

		
		
		if round(data[1],-1) != round(value, -1):
			#print "setting pb"
			img = self.gen_img_path(value, Globals.IMAGE_DIR + im_prefix, im_suffix)
			pb = gtk.gdk.pixbuf_new_from_file(img)
			self.set_data(iter, pb_col, pb)
		#print "setting val"
		self.set_data(iter, data_col, value)
			
				

	
	
	def add(self, 
			pixbuf=None, 
			devtype="cellular",
			connected=False, 
			bonded=False, 
			address="00:00:00:00:00",
			name="unknown",
			lastseen=False,
			rssi=False,
			trusted=False):
		
		#print "add_item"
		
		if not trusted:
			trust_pb = None
		else:
			trust_pb = gtk.gdk.pixbuf_new_from_file(Globals.IMAGE_DIR + "/trust.png");

		if rssi:
			rssi_img = self.gen_img_path(rssi, Globals.IMAGE_DIR + "/signal/rssi/rssi_", ".png")
			rssi_pb = gtk.gdk.pixbuf_new_from_file(rssi_img)
		else:
			rssi_pb = None

		
		if pixbuf == None:
		
			pixbuf = gtk.gdk.pixbuf_new_from_file(Globals.IMAGE_DIR + "/bluetooth.png");
		
		self.buffs = [None]

		
		if bonded:
			
			self.buffs[0] = gtk.gdk.pixbuf_new_from_file(Globals.IMAGE_DIR + "/hasbonding.png");



		if not lastseen:
			lastseen = ""
		else:
			lastseen = "<span size='8000' rise='-40000' weight='light'><b>Last Seen:</b> " + lastseen + "</span>"
		
		
		iter = self.liststore.append(
			[_("<b>Name:</b>") + " " + name + _("\n<b>Device type:</b>") + " " + devtype + _("\n<b>Address:</b>") + " " +address,
			lastseen, 
			address, 
			name, 
			pixbuf,
			rssi_pb,
			self.buffs[0],
			connected,
			bonded,
			None,
			None,
			rssi,
			0,
			0
			,trust_pb,trusted]);
			
		self.row_count=self.row_count+1
		
		if connected:
			if not address in Globals.Connectivity.connections:
				Globals.Connectivity.connections.append(address)
			
			#threading.Thread(target=signals.update_signal, args=(iter, address,)).start()
			cinfo = blueman.conn_info(address, Globals.Settings.adapter)
			self.update_signal(cinfo, address, iter, True)
			gobject.timeout_add(1000, self.update_signal, cinfo, address, iter)



		
	
	def edit_row(self, addr, name="N/A", dev_class=False):
		for i in range(len(self.liststore)):	
			iter = self.liststore[i].iter
			data = self.liststore.get(iter, 0, 1, 2, 3)
			if data[2] == addr:
				#print data[2]
				if not dev_class:
					dev_class = Globals.adapter.GetRemoteMinorClass(addr)
				text = _("<b>Name:</b> %(name)s\n<b>Device type:</b> %(type)s\n<b>Address:</b> %(addr)s" ) % {"name":name,"type":dev_class,"addr":addr}
				
				self.set_data(iter, 0, text)
				self.set_data(iter, 3, name)
	
	

		
	
	def reset(self):
		self.row_count = 0
		self.liststore.clear();
		
		
	def get_iter_by_row(self, rowid):
		try:
			return self.liststore.get_iter_from_string(str(rowid))
		except:
			return None
	
	
	def get_selected_row(self):
		rowid = self.treeview.get_cursor()
		try:
			return self.get_row(rowid[0][0])
		except:
			return None
	
	def get_row(self, rowid):
		iter = self.get_iter_by_row(str(rowid))
		bdaddr = self.liststore.get(iter,2)
		name = self.liststore.get(iter,3)
		isbond = self.liststore.get(iter,8)
		isconn = self.liststore.get(iter,7)
		istrust = self.liststore.get(iter,15)

		return (bdaddr[0], name[0], isconn[0], isbond[0], iter, istrust[0])

	def get_row_from_iter(self, iter):
		bdaddr = self.liststore.get(iter,2)
		name = self.liststore.get(iter,3)
		isbond = self.liststore.get(iter,8)
		isconn = self.liststore.get(iter,7)
		istrust = self.liststore.get(iter,15)

		return (bdaddr[0], name[0], isconn[0], isbond[0], iter, istrust[0])
		
		
	def set_pixbuf(self, iter, col, icon):
		if not icon == None:
			pb = gtk.gdk.pixbuf_new_from_file(Globals.IMAGE_DIR + "/" + icon);
		else:
			pb = None
			
		self.liststore.set(iter, col, pb)
		
	def set_data(self, iter, col, data):
			
		self.liststore.set(iter, col, data)
		
	
	def add_from_list(self, src, show_lastseen=True):
		#self.reset()
		for i in range(len(src)):
			#name = bt.GetRemoteName(test[i])
			name = src[i][1]
			
			try:
				devtype = Globals.adapter.GetRemoteMinorClass(src[i][0])
			except:
				devtype = _("unknown")
			
			try:
				rssi = src[i][2]
			except:
				rssi = False
			
			if show_lastseen:
				try:	
					lastseen = Globals.adapter.LastSeen(src[i][0])
				except:
					lastseen = _("unknown")
			else:
				lastseen = False
				
			try:
				connected = Globals.adapter.IsConnected(src[i][0])
			except:
				connected = False
				
			try:
				bonded = Globals.adapter.HasBonding(src[i][0])
			except:
				bonded = False
				
			try:
				trusted = Globals.adapter.IsTrusted(src[i][0])
			except:
				trusted = False
			
			if not os.path.exists(Globals.IMAGE_DIR + "/devices/" + str(devtype) + ".png"):
				pb = gtk.gdk.pixbuf_new_from_file(Globals.IMAGE_DIR + "/bluetooth.png")
			else:
				pb = gtk.gdk.pixbuf_new_from_file(Globals.IMAGE_DIR + "/devices/" + str(devtype) + ".png")
			
			self.add(pb, devtype, connected, bonded, src[i][0].upper(), name, lastseen, rssi, trusted)
			
		Globals.Statusbar.push(ngettext("Listed %s device", "Listed %s devices", self.row_count) % self.row_count)
			
			#self.statusbar.push(self.context_id,_("Listed %s device(s)") % str(self.list_row_count))
			

	def on_list_cursor_changed(self, treeview):
		
		
		row = self.get_selected_row()
		
		bonded = row[3]
		connected = row[2]
		bdaddr = row[0]	
		trusted = row[5]	
		
		Globals.toolbar.enable_buttons()
		
		

		if not bonded:
			Globals.toolbar.bond1.set_label(_("Bond"))
		else:
			Globals.toolbar.bond1.set_label(_("Unbond"))
			
		
		if not trusted:
			Globals.window.mi_trust.get_child().set_text(_("Set Trusted"))
			im = Globals.window.mi_trust.get_image()
			im.set_from_file(Globals.IMAGE_DIR + "/trust16.png")
		else:
			Globals.window.mi_trust.get_child().set_text(_("Remove Trust"))
			im = Globals.window.mi_trust.get_image()
			im.set_from_file(Globals.IMAGE_DIR + "/trust16_g.png")
			
		if not connected:
			Globals.window.mi_disconnect.set_sensitive(False)
		else:
			Globals.window.mi_disconnect.set_sensitive(True)


	def update_signal(self, cinfo, address, iter,firstrun=False):

		if firstrun:
			self.set_data(iter, 11, -1)
			self.set_data(iter, 12, -1)
			self.set_data(iter, 13, -1)

		if not Globals.Inquiry.active:
			
			if address in Globals.Connectivity.connections and Globals.main_list.liststore.iter_is_valid(iter):
				
				rssi = float(cinfo.get_rssi())
				lq = float(cinfo.get_lq())
				tpl = float(cinfo.get_tpl())
				#print rssi, lq, tpl
				
				rssi_perc = 50 + (rssi / 127 / 2 * 100)
				tpl_perc = 50 + (tpl / 127 / 2 * 100)
				lq_perc = lq / 255 * 100
				

				self.set_signal_for_iter(iter, rssi_perc, 5, 11, "/signal/rssi/rssi_", ".png")
				self.set_signal_for_iter(iter, lq_perc, 9, 12, "/signal/lq/lq_", ".png")
				self.set_signal_for_iter(iter, tpl_perc, 10, 13, "/signal/tpl/tpl_", ".png")

				#print rssi_perc, lq_perc, tpl_perc
			
			else:

				cinfo.deinit()
				return 0


		return 1		
#----------------------------------------------

