#
#
# blueman - statusbar_with_inquiry module
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
import gobject
import gtk

from blueman.Gui.statusbar import statusbar


_ = Globals._

class statusbar_with_inquiry(statusbar):
	def __init__(self):
		
		self.statusbar = Globals.Statusbar.statusbar
		self.statusbar_container = Globals.Statusbar.statusbar_container
		self.statusbar_text = Globals.Statusbar.statusbar_text
		
		#self.context_id = Statusbar.context_id
		
		self.progress_bar = gtk.ProgressBar()
		
		self.label = gtk.Label()
		
		self.sep = gtk.VSeparator()
		self.statusbar_container.pack_start(self.sep, False, False)
		self.statusbar_container.pack_start(self.label,False,False)
		self.statusbar_container.pack_start(self.progress_bar,False,False)

		#self.statusbar.pack_start(self.hbox,False, False)
		
		self.progress_bar.set_size_request(100, 10)
		
		self.progress = 0
		
		
	def inquiry_start(self):
		self.push(_("No devices found"))
		self.progress = 0
		self.progress_bar.set_fraction(0)
		self.statusbar_container.show_all()
		self.label.set_text("Scanning... ")
		self.timer = gobject.timeout_add (100, self.animate)
	
	
	def inquiry_finish(self):
		gobject.source_remove(self.timer)
		self.label.destroy()
		self.progress_bar.destroy()
		self.sep.destroy()
		
		
	def animate(self):
		if Globals.window.page != "inquiry":
			print "Cancel inquiry"
			Globals.Inquiry.CancelDiscovery()
		
		self.progress += 0.009803922
		if self.progress > 1:
			self.progress_bar.pulse()
			self.label.set_text("Resolving Names... ")
		else:
			self.progress_bar.set_fraction(self.progress)
		
		return True

