#
#
# blueman - statusicon module
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
import gtk

_ = Globals._

class statusicon:
	
	def __init__(self, xml):
		
		self.status_icon = gtk.StatusIcon()
		self.status_icon.set_from_file(Globals.IMAGE_DIR + "/bluetooth.png")
		self.status_icon.set_tooltip(_("Blueman - Bluetooth Manager"))
		
		self.status_icon.connect('activate', self.tray_toggle)
		self.status_icon.connect('popup-menu', self.tray_popup)
		
		xml = xml
		self.window = xml.get_widget("window1");
	
	
	
	def tray_toggle(self, tray):
		
		
		
		if not Globals.window.visible():
			self.window.show()
		else:
			self.window.hide()
			
	def on_notifications_activate(self, widget):
		if Globals.Settings.connection_notifications:
			Globals.Settings.connection_notifications = False
			widget.set_active(False)
		else:
			Globals.Settings.connection_notifications = True
			widget.set_active(True)
			
		Globals.Settings.save()
		
	def on_other_notifications_activate(self, widget):
		if Globals.Settings.other_notifications:
			Globals.Settings.other_notifications = False
			widget.set_active(False)
		else:
			Globals.Settings.other_notifications = True
			widget.set_active(True)
			
		Globals.Settings.save()
			
	def tray_popup(self, status_icon, button, activate_time):

		menu = gtk.Menu()
		
		item = gtk.CheckMenuItem(_("Enable Connection Notifications"))
		menu.append(item)
		item.show()
		if Globals.Settings.connection_notifications:
			item.set_active(True)
		else:
			item.set_active(False)
			
		item.connect("toggled", self.on_notifications_activate)
		
		item = gtk.CheckMenuItem(_("Enable Other Notifications"))
		
		
		if Globals.Settings.other_notifications:
			item.set_active(True)
		else:
			item.set_active(False)
			
		item.connect("toggled", self.on_other_notifications_activate)

		
		
		menu.append(item)
		item.show()
		
		item = gtk.SeparatorMenuItem()
		menu.append(item)
		item.show()
		

		item = gtk.ImageMenuItem(_("_Quit"))
		img = gtk.image_new_from_stock(gtk.STOCK_QUIT, gtk.ICON_SIZE_MENU)
		item.set_image(img)
		item.connect("activate", Globals.window.on_window_quit)
		menu.append(item)
		item.show()

		
		menu.popup( None, None, None, button, activate_time)

	def get_geometry(self):
		rect = self.status_icon.get_geometry()[1]
		x = rect.x
		y = rect.y
		w = rect.width
		h = rect.height
		return (x,y,w,h)

