from blueman.Main.config_parser import config_parser
import blueman.Globals as Globals

#
#
# address_cache.py caches bluetooth addresses and restores them
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

class address_cache(config_parser):
	def __init__(self):
		config_parser.__init__(self, "cache")
	
	def push(self, addr, name):
		try:
			self.delete(addr)
		except:
			pass


		#print "cache: adding %s %s" % (addr, name)
		Globals.dbg.info("cache: adding %s -> %s" % (addr, name),8)
		self.add(addr, name)
		
		self.refresh(False)
		self.save()
		
	def pull(self, addr):
		try:
			addr2 = addr.replace(":","-")
			return self.get_option(addr2)
		except:
			return False
