#
#
# config_parser.py
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import ConfigParser, os
class config_parser():	


	def __init__(self, section):
		self.section = section
		self.config = ConfigParser.SafeConfigParser()

		try:
		
			self.refresh()
		
		except ConfigParser.NoSectionError:
			
			self.config.add_section(self.section)
			self.refresh()

		

	def get_option(self, option):
		return self.config.get(self.section, option)
	
	def get(self):
		return self.conf
		
	def refresh(self,rld=True):
		if rld:
			self.config.read(os.path.expanduser("~/.blueman/blueman.conf"))
		
		ls = self.config.items(self.section)
		self.conf = []
		
		for i in range(len(ls)):
			self.conf.append((ls[i][0].replace("-",":"),ls[i][1]))
		  
		  
	def add_unique(self, key, name):
		
		option = key.replace(":","-")
		
		curr = self.get()
		for i in range(len(curr)):
			if curr[i][0].upper() == key:
				return False
		
		self.config.set(self.section, option, name)
		
	
	def add(self, key, val):
		key = key.replace(":","-")
		self.config.set(self.section, key, str(val))
	
	def delete(self, addr):
		addr = addr.replace(":","-")
		self.config.remove_option(self.section, addr)
		

	def save(self):
		if not os.path.exists(os.path.expanduser("~/.blueman")):

			os.mkdir(os.path.expanduser("~/.blueman"))
		
		
		fp = open(os.path.expanduser("~/.blueman/blueman.conf"),"w")
		self.config.write(fp)
		fp.close()
		self.refresh()
