#
#
# signal_handler.py
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals

class signal_handler:

	def __init__(self, sig_class):
		self.__signals = {}
		self.__class = sig_class
		
		Globals.dbg.info("Initializing 'Main.signal_handler' Class", 6)
		
		
	def connect(self, name, handler, *args):
		id = self.__class.connect(name, handler, *args)
		self.__signals[name] = id
		Globals.dbg.info("Connecting GObject Signal '%s'" % name, 7)
		
	def disconnect(self, name):
		Globals.dbg.info("Disconnecting GObject Signal '%s'" % name, 7)
		self.__class.disconnect(self.__signals[name])
		
		
	def disconnect_all(self):
	
		for k, v in self.__signals.iteritems():
			self.disconnect(k)
			
	def deinit(self):
		self.disconnect_all()
		del self.__class
		del self.__signals
		
		Globals.dbg.info("Destroying 'Main.signal_handler' Class", 6)

