#
#
# autostart.py
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import os
import re
import blueman.Globals as Globals

class autostart:

	def __init__(self, id):
		self.service = id
		self.file = "/etc/bluetooth/%s.service" % self.service
		
	def enable(self):
		try:
			os.system('gksu "chmod 777 %s"' % self.file)
			self._setvar(self.file, "Autostart", "true", False)
			os.system('sudo chmod 755 %s' % self.file)
			return True
		except Exception, err:
			return False
		
		
	def disable(self):
		try:
			os.system('gksu "chmod 777 %s"' % self.file)
			self._setvar(self.file, "Autostart", "false", False)
			os.system('sudo chmod 755 %s' % self.file)
			return True
		except Exception, err:
			return False
	
	def is_enabled(self):
		ret = self._getvar(self.file, "Autostart")
		if ret == "true":
			return True
		else:
			return False
		
	def _setvar(self, file, var, value, quotes=True):
		lines = ""
		found = False

		f = open(file, "r")

	
		for line in f:
			if re.match("^"+var, line):
				if quotes:
					lines += var + "=" + '"' + value + '"\n'
				else:
					lines += var + "=" +  value + '\n'
				found = True
			else:
				lines += line
			
		if not found:
			if quotes:
				lines += var + "=" + '"' + value + '"\n'
			else:
				lines += var + "=" +  value + '\n'		
		
			
		f.close()
		f = open(file, "w")
		f.write(lines)
		f.close()
	
	def _getvar(self, file, var):

		f = open(file, "r")

		for line in f:
			if re.match("^"+var, line):
				return line.split("=")[1].strip().strip("\"")
	
		f.close()
