#
#
# input.py
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
import gobject
import dbus
from blueman.Services.bluetooth.generic import generic as generic_service

class input(generic_service):
	__gtype_name__ = 'input_service'
	def __init__(self):
		generic_service.__init__(self, "input")
		
		gobject.signal_new("connect", input, gobject.SIGNAL_RUN_LAST, gobject.TYPE_BOOLEAN, (gobject.TYPE_STRING,))
		gobject.signal_new("disconnect", input, gobject.SIGNAL_RUN_LAST, gobject.TYPE_BOOLEAN, (gobject.TYPE_STRING,))
		gobject.signal_new("device-created", input, gobject.SIGNAL_RUN_LAST, gobject.TYPE_BOOLEAN, (gobject.TYPE_STRING,))
		gobject.signal_new("device-removed", input, gobject.SIGNAL_RUN_LAST, gobject.TYPE_BOOLEAN, (gobject.TYPE_STRING,))
		
	def connect_signals(self):
		self.add_signal(self.on_connect, "Connected", "org.bluez.input.Device", None, None, path_keyword="path", interface_keyword="interface")
        	self.add_signal(self.on_disconnect, "Disconnected", "org.bluez.input.Device", None, None, path_keyword="path", interface_keyword="interface")
		self.add_signal(self.on_device_created, "DeviceCreated", "org.bluez.input.Manager", None, None)
        	self.add_signal(self.on_device_removed, "DeviceRemoved", "org.bluez.input.Manager", None, None)
        	
        def on_connect(self, path, interface):
        	self.emit("connect", path)
        	
        def on_disconnect(self, path, interface):
        	self.emit("disconnect", path)
        	
        def on_device_created(self, path):
        	self.emit("device-created", path)
        	
        def on_device_removed(self, path):
        	self.emit("device-removed", path)
        	
        def get_devices(self):
        	ret = []
        	devs = self.service_manager.ListDevices()
        	for i in range(len(devs)):
            		obj = self.bus.get_object(self.service_bus, devs[i])
            		dev = dbus.Interface(obj, 'org.bluez.input.Device')
            		ret.append((dev,devs[i]))
            
        	return ret
        	
        def get_device(self, path):
      		obj = self.bus.get_object(self.service_bus, path)
    		dev = dbus.Interface(obj, 'org.bluez.input.Device')
    		
    		return dev

