#
#
# gui.generic.py - generic service gui implementation
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
import gtk
import gobject


from blueman.Gui.generic_dialog import generic_dialog

from blueman.Main.signal_handler import signal_handler

class generic(gobject.GObject, generic_dialog):
	
	__gsignals__ = {
		'dialog-destroyed' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, ())
      	}
	
	__gtype_name__ = 'gui_service_base_class'
	
	def __init__(self, identifier):	
		
		Globals.dbg.info("Initializing Services.gui.%s Class" % identifier, 5)
		
		gobject.GObject.__init__(self)

		generic_dialog.__init__(self, "/service_"+identifier+".glade", identifier)
		
		self.service = Globals.Services.get(identifier)
		self.signals = signal_handler(self.service)

	
	def on_connect_in_progress(self, what):
		pass
		
		
	#virtual function
	def __dialog_response__(self, dialog, response):
		self.__destroy__()

		
	def __destroy__(self):
		self.signals.deinit()
		self.dialog.destroy()
		self.emit("dialog-destroyed")
		
        
        def set_notice(self, *args, **kwargs):
        	try:
        		suffix = "_" + kwargs["suffix"]
        	except:
        		suffix = ""
        	
        	hb = self.xml.get_widget("hb_notice"+suffix)
		i = self.xml.get_widget("i_notice"+suffix)
		l = self.xml.get_widget("l_notice"+suffix)
        	
        	icon = args[0]
        	
        	if icon != None:
        		text = args[1]
        		i.set_from_stock(icon, gtk.ICON_SIZE_SMALL_TOOLBAR)
        		l.set_markup(text)
        		hb.show()
        	else:
        		hb.hide()
